<?
/**** Global onstants and file includes ****/
include("connectdb.php");
include("constants.php");
include("security.php");
include("toolbar.php");
define(_THISFILE, "manage_units.php");
$scookie = $_COOKIE[_COOKIE_NAME];

if(connect_db()){
	/****
	We have successfully logged on to the database.  Now we check the user's
	login cookie to make sure they should indeed be here.
	****/
	if(check_login_cookie($scookie, $_SERVER["REMOTE_ADDR"])){
		/*** all looks good.  grab the user ID and touch the cookie. ***/
		$uid = get_id_from_cookie($scookie);
		setcookie(_COOKIE_NAME, $scookie, touch_login_cookie($uid));

		/*** now check to see if this user actually has permission to
		make use of this page.  If not, send them to the main menu. ***/
		$query = "SELECT permissions FROM users WHERE user_id=".$uid;
		$data = mysql_fetch_array(mysql_query($query));
		if($data["permissions"] & _MANAGE_UNITS){
			/*** permissions check out.  draw the web page ***/
			draw_header();
			switch($_POST["action"]){
				case "View": view_unit(); break;
				case "Modify": modify_unit(); break;
				case "Update": update_unit(); break;
				case "Remove": remove_unit(); break;
				case "Add Unit": add_unit(); break;
			}
			draw_default_form();
			draw_toolbar($uid);
			draw_footer();
		}else{
			redirect("the login page", "index.php");
		}
	}else{
		redirect("the login page", "index.php");
	}
}else{
?>
	<h1>Unable to connect to database</h1>
	<p>An error occurred while trying to connect to the database.</p>
<?
}

function draw_header(){
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD html 4.0 Transitional//EN">
<html>
<head>
	<meta name="copyright" content="Copyright 2005, Jacob A. Ewing">
	<title>Unit Management</title>
	<link rel=stylesheet href="presentation.css" type="text/css">
</head>
<body>
	<h1>Unit Management</h1>
<?
}

function draw_footer(){
	echo"</body>\n</html>\n";
}

function draw_default_form(){
?>
	<hr>
	<table width="100%">
	<tr><td class=form_table>
		<h2>Time Units</h2>
		<form method=post action="<?echo _THISFILE?>">
		<table>
		<tr><td>
			<select size=16 name="unitname">
<?
			$query = mysql_query("SELECT name, symbol FROM time_units");

			while($row = mysql_fetch_array($query)){
				echo "<option value=\"".$row["name"]."\">";
				echo $row["name"]." (".$row["symbol"].")";
				echo "</option>\n";
			}
?>
			</select><br>
		</td><td>
			<table>
			<tr><td><input type=submit name="action" value="View"></td></tr>
			<tr><td><input type=submit name="action" value="Modify"></td></tr>
			<tr><td><input type=submit name="action" value="Remove"></td></tr>
			</table>
		</td></tr>
		</table>
		<input type=hidden name="unittype" value="time">
		</form>
	</td><td class=form_table>
		<h2>Distance Units</h2>
		<form method=post action="<?echo _THISFILE?>">
		<table>
		<tr><td>
			<select size=16 name="unitname">
<?
			$query = mysql_query("SELECT name, symbol FROM distance_units");

			while($row = mysql_fetch_array($query)){
				echo "<option value=\"".$row["name"]."\">";
				echo $row["name"]." (".$row["symbol"].")";
				echo "</option>\n";
			}
?>
			</select><br>
		</td><td>
			<table>
			<tr><td><input type=submit name="action" value="View"></td></tr>
			<tr><td><input type=submit name="action" value="Modify"></td></tr>
			<tr><td><input type=submit name="action" value="Remove"></td></tr>
			</table>
		</td></tr>
		</table>
		<input type=hidden name="unittype" value="distance">
		</form>
	</td><td class=form_table>
		<h2>Add A Unit</h2>
		<form method=post action="<?echo _THISFILE?>">
		<table>
			<tr><td>Unit Type:</td><td>
				<select name="unittype">
				<option value="time">Time</option>
				<option value="distance">Distance</option>
				</select>
			</td></tr>
			<tr><td>Unit Name:</td><td><input type=text name="unitname"></td></tr>
			<tr><td>Pluralized Name:</td><td><input type=text name="pluralname"></td></tr>
			<tr><td>Unit Symbol:</td><td><input type=text name="symbol"></td></tr>
			<tr><td><a href="help.php?help_subject=base_units">Value in Base Units:</a></td><td><input type=text name="value"></td></tr>
			<tr><td colspan=2><input type=submit name="action" value="Add Unit">
		</table>
		</form>
	</td></tr>
	</table>
<?
}

function remove_unit(){
	$badargs = 0;
	$unitname = $_POST["unitname"];
	$unittype = $_POST["unittype"];
	if($unitname == "" || $unittype == "") $badargs = 1;

	if($unittype == "time"){
		$tablename = "time_units";
		$basename = "second_value";
	}else if($unittype == "distance"){
		$tablename = "distance_units";
		$basename = "metre_value";
	}else{
		$badargs |= 2;
	}

	if(!$badargs){
		$query = "DELETE FROM ".$tablename." WHERE name=\"".$unitname."\"";
		$success = mysql_query($query) or die("<h1>Error removing unit</h1>\n");
		if($success){
			?><hr><p>Unit successfully deleted</p><?
		}else{
			?><p>There was an error while trying to delete the unit.
			Please contact the system administrator.</p><?
		}
	}else{
		?><h2>Error:</h2>
		<p>Bad arguments were passed to the unit removal function.  Please
		contact the system administrator.</p><?
	}
}

function add_unit(){
	$unittype = $_POST["unittype"];
	$unitname = $_POST["unitname"];
	$pluralname = $_POST["pluralname"];
	$unitsymbol = $_POST["symbol"];
	$unitvalue = $_POST["value"];

	/*** Let's do some error checking ***/
	$error = 0;
	/*** make sure al of the fields are filled out ***/
	if(!$unitname) $error |= 1;
	if(!$pluralname) $error |= 2;
	if(!$unitsymbol) $error |= 4;
	if(!$unitvalue) $error |= 8;
	if(!$unittype) $error |= 16;

	/*** ensure that a valid unit type is specified.  If so, then select
	the appopriate table name to go with it.  ***/
	if($unittype == "time"){
		$tablename = "time_units";
		$value_field = "second_value";
	}else if($unittype == "distance"){
		$tablename = "distance_units";
		$value_field = "metre_value";
	}else{
		$error |= 32;
	}

	/*** make sure the unit name is not already taken.  Don't bother
	to do so if a valid type isn't selected or if a name isn't specified.
	 ***/
	if(!$error & 33){
		$query = "SELECT COUNT(*) FROM ".$tablename;
		$query .= " WHERE name=\"".$unitname."\"";
		$data = mysql_fetch_array(mysql_query($query));
		if($data["COUNT(*)"] != 0) $error |= 64;
	}

	if(!$error){
		/*** Error check is done - no errors found.  Go ahead and insert the data. ***/
		$query = "INSERT INTO ".$tablename."(name, plural, symbol, ".$value_field.") VALUES(";
		$query .= "\"".$unitname."\", ";
		$query .= "\"".$pluralname."\", ";
		$query .= "\"".$unitsymbol."\", ";
		$query .= $unitvalue.")";
		$success = mysql_query($query) or die("<h1>Error inserting data</h1>\n");
		if($success){
			echo "<p>Unit successfully added.</p>\n";
		}else{
			echo "<p>Unable to insert data.  Please contact the system administrator.\n";
		}

	}else{ /*** There's an eror somewhere.  Explain it. ***/
		?><h2>Error:</h2><?
		if($error & 31){
			echo "<p>All fields must be filled out:</p>\n<ul>\n";
			if($error & 1){
				echo "<li> The unit name was not specified.</li>\n";
			}
			if($error & 2){
				echo "<li> The plural of the unit name was not specified.</li>\n";
			}
			if($error & 4){
				echo "<li> The unit symbol was not specified.</li>\n";
			}
			if($error & 8){
				echo "<li> The unit's relative value was not specified.</li>\n";
			}
			if($error & 16){
				echo "<li> A unit type was not selected.</li>\n";
			}
			echo "</ul>\n";
		}
		if($error & 32){
			echo "<p>An invalid unit type has been specified.</p>\n";
			show_hack_warning();
		}
		if($error & 64){
			?><p>The unit name specified is already in use.</p><?
		}
	}
}

function view_unit(){
	$formerror = 0;
	$unittype = $_POST["unittype"];
	$unitname = $_POST["unitname"];

	if($unittype == "time"){
		$table_name = "time_units";
		$value_column_name = "second_value";
		$baseunitname = "Seconds";
	}else if($unittype == "distance"){
		$table_name = "distance_units";
		$value_column_name = "metre_value";
		$baseunitname = "Metres";
	}else{
		$formerror = 1;
		echo "<p>An invalid unit type has been specified.</p>\n";
		show_hack_warning();
	}

	if(!$formerror){
		$query = mysql_query("SELECT * FROM ".$table_name." WHERE name=\"".$unitname."\"");
		$data = mysql_fetch_array($query);
		$pluralname = $data["plural"];
		$unitsymbol = $data["symbol"];
		$unitvalue = $data[$value_column_name];

?>
		<hr>
		<form method=post action="<?echo _THISFILE?>">
		<table class=form_table>
			<tr><td><strong>Unit Type:</strong></td><td><?echo $unittype;?></td></tr>
			<tr><td><strong>Unit Name:</strong></td><td><?echo $unitname;?></td></tr>
			<tr><td><strong>Plural Name:</strong></td><td><?echo $pluralname;?></td></tr>
			<tr><td><strong>Unit Symbol:</strong></td><td><?echo $unitsymbol;?></td></tr>
			<tr><td><strong>Value in <?echo $baseunitname?>:</strong></td><td><?echo $unitvalue;?></td></tr>
			<tr>
			<td><input type=submit name="action" value="Modify"></td>
			<td><input type=submit name="action" value="Remove"></td>
			</tr>
		</table>
		<input type=hidden name="unittype" value=<?echo $unittype?>>
		<input type=hidden name="unitname" value=<?echo $unitname?>>
		<input type=hidden name="pluralname" value=<?echo $pluralname?>>
		<input type=hidden name="unitsymbol" value=<?echo $unitsymbol?>>
		<input type=hidden name="unitvalue" value=<?echo $unitvalue?>>
		</form>
<?
	}
}

function modify_unit(){
	$formerror = 0;
	$unittype = $_POST["unittype"];
	$unitname = $_POST["unitname"];
	$unitsymbol = $_POST["unitsymbol"];
	$unitvalue = $_POST["unitvalue"];
	$pluralname = $_POST["pluralname"];

	if($unittype == "time"){
		$table_name = "time_units";
		$value_column_name = "second_value";
		$baseunitname = "Seconds";
	}else if($unittype == "distance"){
		$table_name = "distance_units";
		$value_column_name = "metre_value";
		$baseunitname = "Metres";
	}else{
		$formerror = 1;
		echo "<p>An invalid unit type has been specified.</p>\n";
		show_hack_warning();
	}

	if(!$formerror){
		$query = mysql_query("SELECT * FROM ".$table_name." WHERE name=\"".$unitname."\"");
		$data = mysql_fetch_array($query);
		if(!$pluralname) $pluralname = $data["plural"];
		if(!$unitsymbol) $unitsymbol = $data["symbol"];
		if(!$unitvalue) $unitvalue = $data[$value_column_name];

?>
		<hr>
		<form method=post action="<?echo _THISFILE?>">
		<table class=form_table>
			<tr>
				<td><strong>Unit Type:</strong></td>
				<td><?echo $unittype;?></td>
			</tr><tr>
				<td><strong>Unit Name:</strong></td>
				<td><input type=text value="<?echo $unitname;?>" name="unitname"></td>
			</tr><tr>
				<td><strong>Plural Name:</strong></td>
				<td><input type=text value="<?echo $pluralname;?>" name="pluralname"></td>
			</tr><tr>
				<td><strong>Unit Symbol:</strong></td>
				<td><input type=text value="<?echo $unitsymbol;?>" name="unitsymbol"></td>
			</tr><tr>
				<td><strong>Value in <?echo $baseunitname?>:</strong></td>
				<td><input type=text value="<?echo $unitvalue;?>" name="unitvalue"></td>
			</tr><tr>
				<td colspan=2><input type=submit name="action" value="Update"></td>
			</tr>
		</table>
		<input type=hidden name="unittype" value=<?echo $unittype?>>
		<input type=hidden name="oldunitname" value=<?echo $unitname?>>
		</form>
<?
	}
}

function update_unit(){
	$formerror = 0;
	$unittype = $_POST["unittype"];
	$unitname = $_POST["unitname"];
	$oldunitname = $_POST["oldunitname"];
	$pluralname = $_POST["pluralname"];
	$unitsymbol = $_POST["unitsymbol"];
	$unitvalue = $_POST["unitvalue"];

	echo "<hr>\n";
	/******** error checking *********/
	/** Check what type of unit we're working with, and catch errors/hacks **/
	if($unittype == "time"){
		$table_name = "time_units";
		$value_column_name = "second_value";
	}else if($unittype == "distance"){
		$table_name = "distance_units";
		$value_column_name = "metre_value";
	}else{
		$formerror |= 32;
	}

	/** make sure the name hasn't been changed to another one that already exists **/
	if(strcmp($unitname, $oldunitname)){
		$query = "SELECT COUNT(name) from ".$table_name." WHERE name=\"".$unitname."\"";
		$data = mysql_fetch_array(mysql_query($query));
		if($data["COUNT(name)"] != 0) $formerror |= 64;
	}

	/** make sure there is a value entered in every field **/
	if(!$unitname) $formerror |= 1;
	if(!$pluralname) $formerror |= 2;
	if(!$unitsymbol) $formerror |= 4;
	if(!$unitvalue){
		$formerror |= 8;
	}else{ /** make sure the value is actually a numeric one **/
		if(!is_numeric($unitvalue))
			$formerror |= 128;
	}
	if(!$unittype) $formerror |= 16;


	if(!$formerror){
		$query = "UPDATE ".$table_name." SET ";
		$query .= "name=\"".$unitname."\", ";
		$query .= "plural=\"".$pluralname."\", ";
		$query .= "symbol=\"".$unitsymbol."\", ";
		$query .= $value_column_name."=\"".$unitvalue."\" ";
		$query .= "WHERE name=\"".$oldunitname."\"";

		$success = mysql_query($query) or die("<h1>Error updating data</h1>\n");
		if($success){
			echo "<p>Unit successfully updated.</p>\n";
		}else{
			echo "<p>Unable to update data.  Please contact the system administrator.\n";
		}
	}else{
		echo "<strong>Error:</strong><br>\n";
		if($formerror & 15){
			echo "<p>All fields must be filled out:</p>\n<ul>\n";
			if($formerror & 1){
				echo "<li> The unit name was not specified.</li>\n";
			}
			if($formerror & 2){
				echo "<li> The plural of the unit name was not specified.</li>\n";
			}
			if($formerror & 4){
				echo "<li> The unit symbol was not specified.</li>\n";
			}
			if($formerror & 8){
				echo "<li> The unit's relative value was not specified.</li>\n";
			}
			echo "</ul>\n";
		}
		if($formerror & 16){
			echo "<p>A unit type was not selected.</p>\n";
			show_hack_warning();
		}
		if($formerror & 32){
			echo "<p>An invalid unit type has been specified.</p>\n";
			show_hack_warning();
		}
		if($formerror & 64){
			echo "<p>The unit name specified is already in use.</p>\n";
		}
		if($formerror & 128){
			echo "<p>The unit value must be a decimal number</p>\n";
		}
		modify_unit();
	}
}

function show_hack_warning(){
	?>
	<p>This error would appear to indicate an attempt at hacking.
	your IP address of <strong><?echo $_SERVER["REMOTE_ADDR"]?></strong> has
	been recorded, and will be reported to the system administrator.</p>
	<?
}

?>
