<?
/**** Global constants and file includes ****/
define(_THISFILE, "manage_users.php");//$_SERVER['PHP_SELF'];
include("constants.php");
include("connectdb.php");
include("security.php");
include("toolbar.php");
$scookie = $_COOKIE[_COOKIE_NAME];

if(connect_db()){
	/****
	We have successfully logged on to the database.  Now we check the user's
	login cookie to make sure they should indeed be here.
	****/
	if(check_login_cookie($scookie, $_SERVER["REMOTE_ADDR"])){
		/*** all looks good.  grab the user ID and touch the cookie. ***/
		$uid = get_id_from_cookie($scookie);
		setcookie(_COOKIE_NAME, $scookie, touch_login_cookie($uid));

		/*** now check to see if this user actually has permission to
		make use of this page.  If not, send them to the main menu. ***/
		$query = "SELECT permissions FROM users WHERE user_id=".$uid;
		$data = mysql_fetch_array(mysql_query($query));
		if($data["permissions"] & _MANAGE_USERS){
			draw_header();
			switch($_POST["action"]){
				case "use_search_results":
					use_search_results();
					break;
				case "Add User":
					add_user();
					break;
				case "Remove":
					remove_user();
					break;
				case "Modify":
					modify_user();
					break;
				case "Update":
					update_user_info();
					break;
				case "View":
					view_user_info();
					break;
				case "Find":
					//search_user_info();
					break;
			}
			draw_default_form();
			draw_toolbar($uid);
			draw_footer();
		}else{
			redirect("the login page", "index.php");
		}
	}else{
		redirect("the login page", "index.php");
	}
}else{
	draw_header();
	echo "<h1>Unable to connect to database</h1>\n";
	echo "<p>An error occurred while trying to connect to the database.</p>\n";
	draw_footer();
}

function use_search_results(){
	switch($_POST["search_action"]){
		case "View":
			view_user_info();
			break;
		case "Modify":
			modify_user();
			break;
		case "Remove":
			remove_user();
			break;
		case "Update":
			update_user_info();
			break;
	}
}

function draw_header(){
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<meta name="copyright" content="Copyright 2005, Jacob A. Ewing">
	<title>User Management</title>
	<link rel=stylesheet href="presentation.css" type="text/css">
</head>
<body>
	<h1>User Management</h1>
<?
}

function draw_footer(){
	echo "</body>\n</html>\n";
}

function draw_default_form(){
?>
	<hr>
	<table>
	<tr><td class=form_table>
		<h2>Existing Users</h2>
		<form method=post action="<?echo _THISFILE?>">
		<table>
		<tr><td>
			<select size=28 name="usernum">
<?
			$query = mysql_query("SELECT user_id, login FROM users");

			while($row = mysql_fetch_array($query)){
				echo "<option value=\"".$row["user_id"]."\">";
				echo $row["user_id"]."  -  ".$row["login"];
				echo "</option>\n";
			}
?>
			</select><br>
		</td><td>
			<table>
			<tr><td><input type=submit name="action" value="View"></td></tr>
			<tr><td><input type=submit name="action" value="Modify"></td></tr>
			<tr><td><input type=submit name="action" value="Remove"></td></tr>
			</table>
		</td></tr>
		</table>
		</form>
	</td><td class=form_table>
		<h2>Add A user</h2>
		<form method=post action="<?echo _THISFILE?>">
		<table>
			<tr><td>
			<table>
				<tr><td>Username:</td><td><input type=text name="add_username"></td></tr>
				<tr><td>Password:</td><td><input type=password name="add_password"></td></tr>
				<tr><td>Confirm Password:</td><td><input type=password name="add_confirmpass"></td></tr>
				<tr><td>Real Name:</td><td><input type=text name="add_name"></td></tr>
				<tr><td>e-mail Address:</td><td><input type=text name="add_email"></td></tr>
				<tr><td>Challenge Question:</td><td><input type=text name="add_question"></td></tr>
				<tr><td>Challenge Answer:</td><td><input type=text name="add_answer"></td></tr>
			</table>
			</td></tr>
			<tr><td class=align_center><strong>This user may:</strong></td></tr>
			<tr><td>
				<?modify_permissions(_DEFAULT_PERMISSIONS)?>
			</td></tr>
			<tr><td colspan=2><input type=submit name="action" value="Add User"></td></tr>
		</table>
		</form>
	</td><td class=form_table>
		<h2>Find A User</h2>
		<form method=post action="<?echo _THISFILE?>">
		<table>
			<tr><td>Username:</td><td><input type=text name="find_username" value="<?echo $_POST["find_username"]?>"></td></tr>
			<tr><td>Real Name:</td><td><input type=text name="find_name" value="<?echo $_POST["find_name"]?>"></td></tr>
			<tr><td>e-mail Address:</td><td><input type=text name="find_email" value="<?echo $_POST["find_email"]?>"></td></tr>
			<tr><td></td><td class=align_right><input type=submit name="action" value="Find"></td></tr>
		</table>
		</form>
<?php		if($_POST["action"] == "Find" || $_POST["action"] == "use_search_results"){
			search_user_info();
		}
?>	</td></tr>
	</table>
<?

}

function search_user_info(){
	$searchlogin = $find_username = $_POST["find_username"];
	$searchname = $find_name = $_POST["find_name"];
	$searchemail = $find_email = $_POST["find_email"];

	/*** take the fields and switch from *nix style wildcards to MySQL type wildcards ***/
	$searchlogin = str_replace("*", "%", $searchlogin);
	$searchname = str_replace("*", "%", $searchname);
	$searchemail = str_replace("*", "%", $searchemail);
	$searchlogin = str_replace("?", "_", $searchlogin);
	$searchname = str_replace("?", "_", $searchname);
	$searchemail = str_replace("?", "_", $searchemail);
	
	/*** build our SQL query ***/
	$numconditions = 0;
	$conditions = "";
	if(strlen($searchlogin)){
		$conditions .= " WHERE login LIKE \"".$searchlogin."\"";
		$numconditions++;
	}

	if(strlen($searchname)){
		if($numconditions) $conditions .= " AND";
		else $conditions .= " WHERE";
		$conditions .= " name LIKE \"".$searchname."\"";
		$numconditions++;
	}

	if(strlen($searchemail)){
		if($numconditions) $conditions .= " AND";
		else $conditions .= " WHERE";
		$conditions .= " email LIKE \"".$searchemail."\"";
	}
	$data = mysql_fetch_array(mysql_query("SELECT COUNT(*) FROM users".$conditions));
	if($data["COUNT(*)"] > 0){
		$query = "SELECT user_id, login, name, email FROM users".$conditions;

?>		<form method=post action="<?echo _THISFILE?>">
		<table>
		<tr><td>
			<select size=20 name="usernum">
<?php				$data = mysql_query($query);
				while($row = mysql_fetch_array($data)){
					echo "<option value=\"".$row["user_id"]."\">";
					echo $row["user_id"]."  -  ".$row["login"];
					echo "</option>\n";
				}
?>				</select><br>
		</td><td>
			<table>
			<tr><td><input type=submit name="search_action" value="View"></td></tr>
			<tr><td><input type=submit name="search_action" value="Modify"></td></tr>
			<tr><td><input type=submit name="search_action" value="Remove"></td></tr>
			</table>
			<input type=hidden name="action" value="use_search_results">
			<input type=hidden name="find_username" value="<?echo $find_username?>">
			<input type=hidden name="find_name" value="<?echo $find_name?>">
			<input type=hidden name="find_email" value="<?echo $find_email?>">
		</td></tr>
		</table>
		</form>
<?php	}else{
		echo "<p>No records found</p>\n";
	}
}

function view_user_info(){
	$query = mysql_query("SELECT * FROM users WHERE user_id=".$_POST["usernum"]);
	$data = mysql_fetch_array($query);
	$user_id = $data["user_id"];
	$username = $data["login"];
	$name = $data["name"];
	$email = $data["email"];
	$question = $data["challenge_question"];
	$answer = $data["challenge_answer"];
	$permissions = $data["permissions"];
	
?>	<form method=post action="<?echo _THISFILE?>">
	<table class=form_table>
		<tr><td>
			<table>
				<tr><td><strong>User ID #:</strong></td><td><?echo $user_id?></td></tr>
				<tr><td><strong>Username:</strong></td><td><?echo $username?></td></tr>
				<tr><td><strong>Name:</strong></td><td><?echo $name?></td></tr>
				<tr><td><strong>e-mail Address:</strong></td><td><?echo $email?></td></tr>
				<tr><td><strong>Challenge Question:</strong></td><td><?echo $question?></td></tr>
				<tr><td><strong>Challenge Answer:</strong></td><td><?echo $answer?></td></tr>
			</table>
		</td><td>
			<?display_permissions($permissions)?>
		</td></tr>
		<tr><td colspan=2>
<?php			if($_POST["action"] == "use_search_results"){
?>				<input type=submit name="search_action" value="Modify">
				<input type=submit name="search_action" value="Remove">
				<input type=hidden name="find_username" value="<?echo $_POST["find_username"]?>">
				<input type=hidden name="find_name" value="<?echo $_POST["find_name"]?>">
				<input type=hidden name="find_email" value="<?echo $_POST["find_email"]?>">
				<input type=hidden name="action" value="use_search_results">
<?php			}else{
?>				<input type=submit name="action" value="Modify">
				<input type=submit name="action" value="Remove">
<?php		}
?>		</td></tr>
	</table>
	<input type=hidden name="usernum" value=<?echo $user_id?>>
	</form>
<?
}

function modify_user(){
	$query = mysql_query("SELECT * FROM users WHERE user_id=".$_POST["usernum"]);
	$olddata = mysql_fetch_array($query);
	$oldusername = $olddata["login"];
	$oldpassword = "";
	$oldname = $olddata["name"];
	$oldemail = $olddata["email"];
	$oldquestion = $olddata["challenge_question"];
	$oldanswer = $olddata["challenge_answer"];
	$oldpermissions = $olddata["permissions"];
	$user_id = $olddata["user_id"];
	
?>	<form method=post action="<?echo _THISFILE?>">
	<table class=form_table width="100%">
		<thead>
			<td>User Information:</td>
			<td>User Permissions:</td>
		</thead>
		<tr><td>
		<table>
			<tr><td>Username:</td><td><input type=text name="username" value="<?echo $oldusername?>"></td></tr>
			<tr><td>Password:</td><td><input type=password name="password" value="<?echo $oldpassword?>"></td></tr>
			<tr><td>Confirm Password:</td><td><input type=password name="confirmpass" value="<?echo $oldpassword?>"></td></tr>
			<tr><td>Real Name:</td><td><input type=text name="name" value="<?echo $oldname?>"></td></tr>
			<tr><td>e-mail Address:</td><td><input type=text name="email" value="<?echo $oldemail?>"></td></tr>
			<tr><td>Challenge Question:</td><td><input type=text name="question" value="<?echo $oldquestion?>"></td></tr>
			<tr><td>Challenge Answer:</td><td><input type=text name="answer" value="<?echo $oldanswer?>"></td></tr>
			<tr><td colspan=2>
<?php				if($_POST["action"] == "use_search_results"){
?>					<input type=submit name="search_action" value="Update">
					<input type=hidden name="find_username" value="<?echo $_POST["find_username"]?>">
					<input type=hidden name="find_name" value="<?echo $_POST["find_name"]?>">
					<input type=hidden name="find_email" value="<?echo $_POST["find_email"]?>">
					<input type=hidden name="action" value="use_search_results">
<?php				}else{
?>					<input type=submit name="action" value="Update">
<?php				}
?>			</td></tr>
		</table>
		</td><td>
		<?modify_permissions($oldpermissions);?>
		</td></tr>
	</table>
	<input type=hidden name=user_id value=<?echo $user_id?>>
	</form>

<?
}

function update_user_info(){
	$username = $_POST['username'];
	$password = $_POST['password'];
	$confirmpass = $_POST['confirmpass'];
	$name = $_POST['name'];
	$email = $_POST['email'];
	$question = $_POST['question'];
	$answer = $_POST['answer'];
	$user_id = $_POST['user_id'];
	$permissions = 0;
	for($n = 0; $n < _NUM_MANAGE_FLAGS; $n++){
		$bitvalue = (1 << $n);
		if($_POST["pflag".$bitvalue] == 1){
			$permissions += (int)$bitvalue;
		}
	}

	/*** make sure all of the required fields were filled out.  Note that
	the password field won't be required here, so that the user can be
	modified without having to re-enter or decrypt the password.
	***/
	$formfilled = ($username != "");
	$formfilled &= ($name != "");
	$formfilled &= ($email != "");
	$formfilled &= ($question != "");
	$formfilled &= ($answer != "");

	if(!$formfilled){ /** not all fields in the form were filled out **/
?>		<p>You do not appear to have filled out all of the required fields.
		Please go back to the previous page and ensure that all required
		fields are filled.</p>
<?php	}else{/** all fields filled, now check their validity **/
		/*** check the validity of the username, and make sure it's not taken ***/
		if(strlen($username) < 4 || strlen($username) > 32){
			$badusername = $baddata= 1;
		}else{
			$query = mysql_fetch_array(mysql_query("SELECT COUNT(login) FROM users WHERE login=\"".$username."\" AND user_id<>".$user_id));
			if($query["COUNT(login)"] != "0"){
				$username_taken = $baddata = 1;
			}
		}

		/*** check the validity of the password, and make sure it matches the confirmed one ***/
		if(strcmp($password, $confirmpass)){
			$unmatched_password = $baddata = 1;
		}else{
			$len = strlen($password);
			if(($len < 5 || $len > 32) && $len != 0)
				$badpasslength = $baddata = 1;
		}

		if($baddata){
?>			<h3>Unable to modify user:</h3>
			<ul>
<?php			/** at least one piece of the data submitted is invalid.  Give the user
			any pertinent error messages **/
			if($badusername){
?>				<li>The username must be between 4 and 32 characters.  The one you entered
				does not meet this requirement.</li>
<?php			}

			if($username_taken){
?>				<li>The username you have chosen is already taken.</li>
<?php			}

			if($unmatched_password){
?>				<li>The "password" and "confirm password" fields do not match.  Please
				note that passwords are case-sensitive.</li>
<?php			}

			if($badpasslength){
?>				<li>The password you choose must be between 5 and 32 characters.</li>
<?php			}
?>			</ul>
			<p>You can use your browser's "back" button to return to the previous
			page and make the necessary corrections.</p>
<?php		}else{ /** all data submitted clears out.  Add the user to the database **/
			$query = "UPDATE users SET ";
			$query .= "login=\"".$username."\", ";
			if($password != "")
				$query .= "password=encode(\"".$password."\", \"".$password."\"), ";
			$query .= "permissions=".$permissions.", ";
			$query .= "name=\"".$name."\", ";
			$query .= "email=\"".$email."\", ";
			$query .= "challenge_question=\"".$question."\", ";
			$query .= "challenge_answer=\"".$answer."\"";
			$query .= "WHERE user_id=".$user_id;
			$success = mysql_query($query)
				or die("<h1>Error updating data</h1>\n<p>Unable to update user. Please contact the system administrator.</p>\n");
			if($success){
				echo "<p>Account successfully modified</p>\n";
			}
		}
	}
}

function remove_user(){
	/****************************
	!!!!IMPORTANT!!!!
	This function should be rewritten so that, when a user is deleted, their user
	info is moved into a "deleted_users" table, but their other data remains stored.
	This can be stored for an arbitrary amount of time until it is either archived
	in another database or completely removed.
	****************************/
	$idnum = $_POST["usernum"];
	$query = "DELETE FROM users WHERE user_id=".$idnum;
	$success = mysql_query($query) or die("<h1>Error removing user</h1>\n");
	if($success){
		/*** remove all of the user's data from other tables ***/
		mysql_query("DELETE FROM memberships WHERE user_id=".$idnum);
		mysql_query("DELETE FROM trips WHERE user_id=".$idnum);
		mysql_query("DELETE FROM vehicles WHERE user_id=".$idnum);

?>		<p>User successfully deleted</p>
<?php	}else{
?>		<p>There was an error while trying to delete the user.
		Please contact the system administrator.</p>
<?php	}
}

function add_user(){
	$add_username = $_POST['add_username'];
	$add_password = $_POST['add_password'];
	$add_confirmpass = $_POST['add_confirmpass'];
	$add_name = $_POST['add_name'];
	$add_email = $_POST['add_email'];
	$add_question = $_POST['add_question'];
	$add_answer = $_POST['add_answer'];

	$add_permissions = 0;
	for($n = 0; $n < _NUM_MANAGE_FLAGS; $n++){
		$bitvalue = (1 << $n);
		if($_POST["pflag".$bitvalue] == 1){
			$add_permissions += (int)$bitvalue;
		}
	}


	/*** make sure ~ALL~ of the fields were filled out ***/
	$formfilled = ($add_username != "");
	$formfilled &= ($add_password != "");
	$formfilled &= ($add_confirmpass != "");
	$formfilled &= ($add_name != "");
	$formfilled &= ($add_email != "");
	$formfilled &= ($add_question != "");
	$formfilled &= ($add_answer != "");

	if(!$formfilled){ /** not all fields in the form were filled out **/
?>		<p>You do not appear to have filled out all of the fields in the
		"Add a User" form.  Please go back to the previous page and ensure
		that every filed is filled out.</p>
<?php	}else{/** all fields filled, now check their validity **/
		/*** check the validity of the username, and make sure it's not taken ***/
		if(strlen($add_username) < 2 || strlen($add_username) > 32){
			$badusername = $baddata= 1;
		}else{
			$query = mysql_fetch_array(mysql_query("SELECT COUNT(login) FROM users WHERE login=\"".$username."\""));
			if($query["COUNT(login)"] != "0"){
				$username_taken = $baddata = 1;
			}
		}

		/*** check the validity of the password, and make sure it matches the confirmed one ***/
		if(strcmp($add_password, $add_confirmpass)){
			$unmatched_password = $baddata = 1;
		}else if(strlen($add_password) < 5 || strlen($add_password) > 32){
			$badpasslength = $baddata = 1;
		}

		if($baddata){
?>			<h3>Unable to create user:</h3>
			<ul>
<?php			/** at least one piece of the data submitted is invalid.  Give the user
			any pertinent error messages **/
			if($badusername){
?>				<li>The username must be between 2 and 32 characters.  The one you entered
				does not meet this requirement.</li>
<?php			}

			if($username_taken){
?>				<li>The username you have chosen is already taken.</li>
<?php			}

			if($unmatched_password){
?>				<li>The "password" and "confirm password" fields do not match.  Please
				note that passwords are case-sensitive.</li>
<?php			}

			if($badpasslength){
?>				<li>The password you choose must be between 5 and 32 characters.</li>
<?php			}
?>			</ul>
			<p>You can use your browser's "back" button to return to the previous
			page and make the necessary corrections.</p>
<?php		}else{ /** all data submitted clears out.  Add the user to the database **/
			$query = "INSERT INTO users (login, password, permissions, name, email, challenge_question, challenge_answer) VALUES(";
			$query .= "\"".$add_username."\", ";
			$query .= "encode(\"".$add_password."\", \"".$add_password."\"), ";
			$query .= $add_permissions.", ";
			$query .= "\"".$add_name."\", ";
			$query .= "\"".$add_email."\", ";
			$query .= "\"".$add_question."\", ";
			$query .= "\"".$add_answer."\")";
			$success = mysql_query($query) or die("<h1>Error inserting data</h1>\n");
			if($success){
				echo "<p>New user successfully created</p>\n";
			}else{
				echo "<p>Unable to create user.  Please contact the system administrator.</p>\n";
			}
		}
	}
}

function display_permissions($permissions){
	$all_manage_flags = 0;
	for($n = 0; $n < _NUM_MANAGE_FLAGS; $n++){
		$all_manage_flags |= (1 << $n);
	}
	?><p><strong>Permissions:</strong> <?
	if($permissions & $all_manage_flags){
		echo "<br>\nThis user may:\n<ul>\n";
		for($n = 0; $n < _NUM_MANAGE_FLAGS; $n++){
			$pflag = 1 << $n;
			if($pflag & $permissions){
				echo "<li>";
				switch($pflag){
					case _MANAGE_OWN_TRIPS:
						echo "Manage personal trip records";
						break;
					case _MANAGE_OWN_VEHICLES:
						echo "Manage personal vehicles";
						break;
					case _MANAGE_OWN_GROUPS:
						echo "Manage personal groups";
						break;
					case _MANAGE_ALL_GROUPS:
						echo "Manage all groups";
						break;
					case _MANAGE_ALL_VEHICLES:
						echo "Manage all vehicles";
						break;
					case _MANAGE_ALL_TRIPS:
						echo "Manage all trip records";
						break;
					case _MANAGE_UNITS:
						echo "Manage units of measurement";
						break;
					case _MANAGE_USERS:
						echo "Manage all users";
						break;
					case _MANAGE_CREATE_GROUPS:
						echo "Create groups";
						break;
				}
				echo "</li>\n";
			}
		}
		echo "</ul>\n";
	}else{
		echo "None";
	}
	echo "</p>\n";
}

function modify_permissions($permissions){
	/***
	NOTE:  this function only displays a component of a form.  That is, it displays
	a series of checkboxes that belong in a form, but does not display the rest of the
	form.  The call to this function should be nested within a form.
	***/
	echo "<table>\n";
	for($n = 0; $n < _NUM_MANAGE_FLAGS; $n++){
		$pflag = 1 << $n;
		echo "<tr><td><input type=checkbox name=\"pflag".$pflag."\" value=1";
		if($pflag & $permissions){
			echo " checked";
		}
		echo "></td><td>";
		switch($pflag){
			case _MANAGE_OWN_TRIPS:
				echo "Manage personal trip records";
				break;
			case _MANAGE_OWN_VEHICLES:
				echo "Manage personal vehicles";
				break;
			case _MANAGE_OWN_GROUPS:
				echo "Manage personal groups";
				break;
			case _MANAGE_ALL_GROUPS:
				echo "Manage all groups";
				break;
			case _MANAGE_ALL_VEHICLES:
				echo "Manage all vehicles";
				break;
			case _MANAGE_ALL_TRIPS:
				echo "Manage all trip records";
				break;
			case _MANAGE_UNITS:
				echo "Manage units of measurement";
				break;
			case _MANAGE_USERS:
				echo "Manage all users";
				break;
			case _MANAGE_CREATE_GROUPS:
				echo "Create groups";
				break;
		}
		echo "</td></tr>\n";
	}
	echo "</table>\n";
}
?>
