<?
################################
#ifndef __SECURITY_PHP
if(!defined("__SECURITY_PHP")){
define('__SECURITY_PHP', 1);
################################

include("connectdb.php");
define('_EXPIRY_PERIOD', 900); /* 900 seconds, ie. 15 minutes */
define('_COOKIE_NAME', "JKLH3289dhas");
/********************
This is a group of functions for handling login security.
The concept of the security for this page is a relatively simple one.

Here is how the process works:

to log a user into the system{
	do{
		- User logs in
		if(successful){
			- generate a cookie with a random  value
			- note that cookie in a database with value, user, IPA, and expiry
			- send the cookie to the browser
		}else{
			- state that the login was not successful
		}
	}while(!successful);
}

every time the user tries to load a page{
	- check the security database to find the login cookie for that user
	if(cookie is not found or cookie's time has run out){

		- send them back to the login screen

	}else if(the client's IPA does not match the one in the database){

		- smells like a hacking attempt.
	}else{
		- generate the web page and send it to them
	}
}
********************/
function read_user_permissions($user_id){
	$query = "SELECT permissions FROM users WHERE user_id=".$user_id;
	$data = mysql_fetch_array(mysql_query($query));
	return $data['permissions'];
}

function read_user_id($user){
	$data = mysql_fetch_array(mysql_query("SELECT user_id FROM users WHERE login=\"".$user."\""));
	return $data["user_id"];
}

function get_id_from_cookie($cookie){
	$query = "SELECT user_id FROM security WHERE cookie_value=\"".$cookie."\"";
	$data = mysql_fetch_array(mysql_query($query));
	return $data["user_id"];
}

function validate_password($user, $pass){
	$returnval = FALSE;
	if(connect_db()){
		$query = "SELECT count(login) FROM users WHERE login=\"".$user."\" AND password=encode(\"";
		$query .= $pass."\", \"".$pass."\")";
		$data = mysql_fetch_array(mysql_query($query));
		if($data['count(login)'] == 1){
			$returnval = TRUE;
		}
	}else{
?>
		<h1>Unable to connect to database</h1>
		<p>An error occurred while trying to connect to the database.</p>
<?
	}
	return $returnval;
}

/***
Generates the cookie for the user and throws it in the database.
***/
function create_login_cookie($user_id, &$cookievalue){
	wipe_login_cookies();
	if(check_login_state($user_id)){
		/*** there is already a record of them being logged in.  drop it. ***/
		delete_login_cookie($user_id);
	}

	$cookievalue = "";
	for($n = 0; $n < 32; $n++){
		$cookievalue .= random_character();
	}

	/* ok, the cookie name and value have been generated, now put them in the database */
	$query = "INSERT INTO security (user_id, cookie_value, expiry_time, IP_address) VALUES(";
	$query .= $user_id.", \"".$cookievalue."\", ";
	$query .= (time() + _EXPIRY_PERIOD).", ";
	$query .= "\"".$_SERVER['REMOTE_ADDR']."\")";
	mysql_query($query);
}

/***
Resets and returns the expiration time of the cookie for this user, sending
the cookie itself to their browser and tracking it in the database.
***/
function touch_login_cookie($user_id){
	$newtime = time() + _EXPIRY_PERIOD;
	$query = "UPDATE security SET expiry_time=\"".$newtime."\" WHERE user_id=".$user_id;
	mysql_query($query);
	return $newtime;
}

/***
drops all expired cookies from the database.
***/
function wipe_login_cookies(){
	mysql_query("DELETE FROM security WHERE expiry_time < ".time());
}

/***
Removes the user's cookie from the database, effectively logging them out.
***/
function delete_login_cookie($user_id){
	mysql_query("DELETE FROM security WHERE user_id=".$user_id);
}

/***
check the cookie, make sure it matches the IP it's originally from, and
ensure that it hasn't expired.
***/
function check_login_cookie($cookie_value, $IPA){
	$returnval = FALSE;
	$query = "SELECT expiry_time, user_id FROM security WHERE ";
	$query .= "IP_address=\"".$IPA."\" AND ";
	$query .= "cookie_value=\"".$cookie_value."\"";
	$data = mysql_fetch_array(mysql_query($query));
	if($data['expiry_time'] > time()){
		$returnval = TRUE;
	}
	wipe_login_cookies();

	return $returnval;
}

/***
This function returns a simple boolean determining whether or not
the user is looged in.  If they are logged in, return TRUE, otherwise
return FALSE.
***/
function check_login_state($user_id){
	$returnval = 1;

	/*********
	First, check to see if they're already logged in.  If they are, make
	sure it's not a matter of the cookie having expired and the record
	still being in the database.
	*********/
	$query = "SELECT COUNT(*) FROM security WHERE user_id=".$user_id;
	$data = mysql_fetch_array(mysql_query($query));
	$numlogins = $data['COUNT(*)'];
	if($numlogins == 1){
		/* this user already has a cookie in the database */
		$query = "SELECT expiry_time FROM security WHERE user_id=".$user_id;
		$data = mysql_fetch_array(mysql_query($query));
		if($data['expiry_time'] <= time()){
			/* it has, however, expired.  Drop it. */
			$returnval = 0;
			mysql_query("DELETE FROM security WHERE user_id=".$user_id);
		}
	}else if($numlogins == 0){
		$returnval = 0;
	}else{
		/*** This else should never be reached.  This may indicate
		an attempt at hacking, but more likely just a script error. ***/
		$returnval = 0;
		echo "<p><strong>Multiple login error.</strong> This should not be happening, ";
		echo "please contact the system administrator.</p>\n";
	}
	return $returnval;
}

/***
Returns a random alphanumeric character
***/
function random_character(){
	$num = rand() % 62;

	if($num < 26)
		$returnval = chr(ord('a') + $num);
	else if($num < 52)
		$returnval = chr(ord('A') + ($num - 26));
	else
		$returnval = chr(ord('0') + ($num % 10));

	return $returnval;
}

/****
redirects the browser to a page specified in the "page" argument.
****/
function redirect($description, $url){
	header("Location: ". $url);
/*?>
<!DOCTYPE html PUBLIC "-//W3C//DTD html 4.0 Transitional//EN">
<html>
<head>
	<meta name="copyright" content="Copyright 2005, Jacob A. Ewing">
	<meta http-equiv=Refresh CONTENT="0; URL=<?echo $url?>">
</head>
<body>
	<p>You are being redirected to <?echo $description?>.
	Go <a href="<?echo $url?>">here</a> if your browser does not
	do so automatically.</p>
</body>
</html>
<?*/
}

/**
redirects the user's browse to the main login page.
**/
function redirect_login_page(){
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD html 4.0 Transitional//EN">
<html>
<head>
	<meta name="copyright" content="Copyright 2005, Jacob A. Ewing">
	<meta http-equiv=Refresh CONTENT="0; URL=login.php">
</head>
<body>
	<p>click <a href="login.php">here</a> to log in.</p>
</body>
</html>
<?
}

################################
}#ifndef __SECURITY_PHP
################################
?>
